Index: /controller/wpsg_OrderController.class.php
===================================================================
--- /controller/wpsg_OrderController.class.php	(revision 7915)
+++ /controller/wpsg_OrderController.class.php	(revision 7916)
@@ -1090,5 +1090,5 @@
                 
 			} else if (wpsg_isSizedString($_REQUEST['subaction'], 'editVoucher')) {
-			
+
 		    	/** @var \wpsg\wpsg_calculation */
 				$this->shop->view['oCalculation'] = new \wpsg\wpsg_calculation();
@@ -1108,6 +1108,6 @@
 							
 							if (wpsg_isSizedInt($_REQUEST['be_voucher_coupon'])) {
-								
-								$this->shop->view['oCalculation']->addCoupon($_REQUEST['be_voucher_amount'], $this->shop->getBackendTaxview(), '0', 1, $_REQUEST['be_voucher_code'], $_REQUEST['be_voucher_id'], $_REQUEST['order_voucher_id']);
+						 
+								$this->shop->view['oCalculation']->addCoupon(wpsg_tf($_REQUEST['be_voucher_amount']), $this->shop->getBackendTaxview(), '0', 1, $_REQUEST['be_voucher_code'], $_REQUEST['be_voucher_id'], $_REQUEST['order_voucher_id']);
 								
 							} else {
Index: /lib/wpsg_calculation.class.php
===================================================================
--- /lib/wpsg_calculation.class.php	(revision 7915)
+++ /lib/wpsg_calculation.class.php	(revision 7916)
@@ -193,5 +193,5 @@
 		
 		public function addCoupon($set, $bruttonetto, $tax_key, $amount = 1, $code = false, $id = false, $order_voucher_id = 0) {
-
+ 
 			$tax_key = $this->normalizeTaxKey($tax_key);
 			
@@ -438,6 +438,6 @@
 	            }
 
-                foreach ($this->arCalculationRow as $cr) {
-                	             
+                foreach ($this->arCalculationRow as $k_cr => $cr) {
+   
                 	if ($cr['type'] === 'coupon') continue;
                 	 
@@ -567,5 +567,8 @@
 																
 								list($set_netto, $set_brutto) = $this->calculateTaxPart(WPSG_BRUTTO, $set_brutto, $cr['tax_key']);
-								 
+								
+								$this->arCalculationRow[$k_cr]['set_netto'] = $set_netto;
+								$this->arCalculationRow[$k_cr]['set_brutto'] = $set_brutto;
+								
 								//wpsg_debug('2: '.$set_netto.":".$set_brutto);
 							}
@@ -702,9 +705,14 @@
 		                			list($scope_set_netto, $scope_set_brutto) = $this->calculateTaxPart($cr2['bruttonetto'], $cr2['set'], $cr2['tax_key']);
 
-		                			$scope_netto -= $scope_set_netto;
-		                			$scope_brutto -= $scope_set_brutto;
+		                			$scope_netto -= $scope_set_netto * $cr2['amount'];
+		                			$scope_brutto -= $scope_set_brutto * $cr2['amount'];
 
 				                } else $cr['data']['partial'] = true;
 
+			                } else if (in_array($cr2['type'], ['shipping', 'payment'])) {
+		                		
+		                		$scope_netto -= $cr2['set_netto'];
+		                		$scope_brutto -= $cr2['set_brutto'];
+		                		
 			                }
 
@@ -745,5 +753,7 @@
 
 							//if ($cr['set'] < abs($set_brutto)) $set_brutto = -1 * $cr['set'];
-
+							 
+							$set_brutto = wpsg_tf($set_brutto);
+							
 							if (($this->arCalculation['sum']['brutto'] + $set_brutto) < 0) $set_brutto = -1 * $this->arCalculation['sum']['brutto'];
 
Index: /mods/wpsg_mod_abo.class.php
===================================================================
--- /mods/wpsg_mod_abo.class.php	(revision 7915)
+++ /mods/wpsg_mod_abo.class.php	(revision 7916)
@@ -854,4 +854,6 @@
 		public function order_view_row(&$p, $i) {
 
+			$this->shop->view['i'] = $i;
+
 			if (substr(wpsg_getStr($p['product_key']), 0, 3) == 'abo') {
 
@@ -862,7 +864,5 @@
 				return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_abo/order_view_row.phtml');
 
-			}
-			else
-			{
+			} else {
 
 				$product_data = $this->shop->cache->loadProduct($p['product_id']);
@@ -1632,15 +1632,16 @@
             $customer_data = $this->shop->cache->loadKunden($order_data['k_id']);
                         
-            $this->shop->view['oProduct'] = $this->shop->cache->loadProductObject($product_data['id']);
+            $this->shop->view['oProduct'] = wpsg_product::getInstance($product_data['id']);
             $this->shop->view['product'] = $product_data;
             $this->shop->view['customer'] = $customer_data;
             $this->shop->view['order'] = $order_data;
             $this->shop->view['wpsg_mod_abo_autoexpire_informationtime'] = $this->getSetting('wpsg_mod_abo_autoexpire_informationtime', $product_id);
-            
+            $this->shop->view['rebuyLink'] = $this->getRebuyLink($order_id, $order_product_id);
+
             if ($this->shop->get_option('wpsg_htmlmail') === '1') $mail_html = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_abo/mail_autoinformation_html.phtml', false);
             else $mail_html = false;
-            
+
             $mail_text = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_abo/mail_autoinformation.phtml', false);
-
+ 
             $this->shop->sendMail($mail_text, $customer_data['email'], 'wpsgmodabautoinfo', array(), $order_id, $customer_data['id'], $mail_html);
             
Index: /views/mods/mod_abo/mail_autoinformation.phtml
===================================================================
--- /views/mods/mod_abo/mail_autoinformation.phtml	(revision 7915)
+++ /views/mods/mod_abo/mail_autoinformation.phtml	(revision 7916)
@@ -5,7 +5,12 @@
 	 */
 
+	/** @var wpsg_product $oProduct */
+	$oProduct = $this->view['oProduct'];
+
 ?><?php echo __('Hallo', 'wpsg'); ?> <?php echo wpsg_hspc($this->view['customer']['vname']); ?> <?php echo wpsg_hspc($this->view['customer']['name']); ?>,
+
+<?php echo wpsg_translate(__('Ihr Abonnement von Produkt "#1#" lÃ€uft in #2# Tagen aus.', 'wpsg'), $this->view['oProduct']->getProductName(), $this->view['wpsg_mod_abo_autoexpire_informationtime']); ?> 
  
-<?php echo wpsg_translate(__('Ihr Abonnement von Produkt "#1#" wird in #2# Tagen automatisch verlÃ€ngert.', 'wpsg'), $this->view['oProduct']->getProductName(), $this->view['wpsg_mod_abo_autoexpire_informationtime']); ?>  
+<?php echo wpsg_translate(__('Klicken Sie <a href="#1#">hier</a> um das Abonnement zu verlÃ€ngern.', 'wpsg'), $this->view['rebuyLink']); ?>  
  
 <?php echo __('Viele GrÃŒÃe', 'wpsg'); ?> 
Index: /views/mods/mod_abo/mail_autoinformation_html.phtml
===================================================================
--- /views/mods/mod_abo/mail_autoinformation_html.phtml	(revision 7915)
+++ /views/mods/mod_abo/mail_autoinformation_html.phtml	(revision 7916)
@@ -6,7 +6,9 @@
 
 ?><p><?php echo __('Hallo', 'wpsg'); ?> <?php echo wpsg_hspc($this->view['customer']['vname']); ?> <?php echo wpsg_hspc($this->view['customer']['name']); ?>,</p>
+  
+<p><?php echo wpsg_translate(__('Ihr Abonnement von Produkt "#1#" lÃ€uft in #2# Tagen aus.', 'wpsg'), $this->view['oProduct']->getProductName(), $this->view['wpsg_mod_abo_autoexpire_informationtime']); ?></p> 
  
-<p><?php echo wpsg_translate(__('Ihr Abonnement von Produkt "#1#" wird in #2# Tagen automatisch verlÃ€ngert.', 'wpsg'), $this->view['oProduct']->getProductName(), $this->view['wpsg_mod_abo_autoexpire_informationtime']); ?></p> 
- 
+<p><?php echo wpsg_translate(__('Klicken Sie <a href="#1#">hier</a> um das Abonnement zu verlÃ€ngern.', 'wpsg'), $this->view['rebuyLink']); ?></p>
+
 <p><?php echo __('Viele GrÃŒÃe', 'wpsg'); ?></p> 
  
Index: /views/mods/mod_abo/order_view_base.phtml
===================================================================
--- /views/mods/mod_abo/order_view_base.phtml	(revision 7915)
+++ /views/mods/mod_abo/order_view_base.phtml	(revision 7916)
@@ -4,4 +4,5 @@
 	 * Integration einer Abo-VerlÃ€ngerung in die Bestellansicht im Backend (Abo Produkt)
 	 */
+
 ?>
 <tr class="wpsg_<?php echo (($this->view['i'] == 0)?'odd':'even'); ?>">
Index: /views/mods/mod_su/order_done.phtml
===================================================================
--- /views/mods/mod_su/order_done.phtml	(revision 7915)
+++ /views/mods/mod_su/order_done.phtml	(revision 7916)
@@ -9,5 +9,5 @@
 <p>
 	<a title="<?php echo __('Mit SofortÃŒberweisung bezahlen', 'wpsg'); ?>" href="<?php echo $this->view['suLink']; ?>">
-		<img src="<?php echo WPSG_URL_CONTENT.'plugins/'.WPSG_FOLDERNAME.'/views/gfx/'; ?>banner_300x100.png" align="left" alt="<?php echo __('Mit SofortÃŒberweisung bezahlen', 'wpsg'); ?>" style="margin-right:7px;">
+		<img src="<?php echo $this->getRessourceURL('mods/mod_su/gfx/logo_100x25.png'); ?>" alt="<?php echo __('Mit SofortÃŒberweisung bezahlen', 'wpsg'); ?>" style="margin-right:7px;">
 	</a>
 </p>