Index: /controller/wpsg_OrderController.class.php
===================================================================
--- /controller/wpsg_OrderController.class.php	(revision 8226)
+++ /controller/wpsg_OrderController.class.php	(revision 8227)
@@ -203,9 +203,9 @@
                     'payment_key' => wpsg_q($_REQUEST['add_payment']),
                     'payment_bruttonetto' => wpsg_q($this->shop->getBackendTaxview()),
-					'payment_tax_key' => wpsg_q($this->shop->arPayment[$_REQUEST['add_payment']]['mwst_key']),
+					'payment_tax_key' => wpsg_q($this->shop->arPayment[$_REQUEST['add_payment']]['mwst_key']??''),
 					'payment_set' => wpsg_q($this->shop->arPayment[$_REQUEST['add_payment']]['price']),
 					'shipping_key' => wpsg_q($_REQUEST['add_shipping']),
 					'shipping_bruttonetto' => wpsg_q($this->shop->getBackendTaxview()),
-					'shipping_tax_key' => wpsg_q($this->shop->arShipping[$_REQUEST['add_shipping']]['mwst_key']),
+					'shipping_tax_key' => wpsg_q($this->shop->arShipping[$_REQUEST['add_shipping']]['mwst_key']??''),
 					'shipping_set' => wpsg_q($this->shop->arShipping[$_REQUEST['add_shipping']]['price']),
                     'price_frontend' => $this->shop->getFrontendTaxview(),
@@ -1358,5 +1358,5 @@
 
 			$this->shop->view['oOrder'] = wpsg_order::getInstance($_REQUEST['edit_id']);
-			
+
 			$basket = new wpsg_basket();
 			$basket->initFromDB($this->shop->view['data']['id'], true);
@@ -1365,8 +1365,7 @@
 			$this->shop->view['arPayment'] = $this->shop->arPayment;
 			$this->shop->view['arShipping'] = $this->shop->arShipping;
-			
+
 			$oCalculation = new \wpsg\wpsg_calculation();
 			$oCalculation->fromDB($this->shop->view['data']['id']);
-			
 			$this->shop->view['oCalculation'] = $oCalculation;
 			
@@ -1381,6 +1380,6 @@
             }
 
-            $oCalculation = new \wpsg\wpsg_calculation();
-            $oCalculation->fromDB($this->shop->view['data']['id']);
+			$oCalculation = new \wpsg\wpsg_calculation();
+			$oCalculation->fromDB($this->shop->view['data']['id']);
 
             $this->shop->checkShippingAvailable();
Index: /lib/wpsg_basket.class.php
===================================================================
--- /lib/wpsg_basket.class.php	(revision 8226)
+++ /lib/wpsg_basket.class.php	(revision 8227)
@@ -386,5 +386,5 @@
 					 	LEFT JOIN `".WPSG_TBL_ADRESS."` AS A ON (A.`id` = K.`adress_id`)
 				WHERE
-					K.`id` = '".wpsg_q($order['k_id'])."'
+					K.`id` = '".wpsg_q($order['k_id']??'')."'
 			");
 
@@ -407,10 +407,10 @@
 				'ustidnr' => wpsg_getStr($kunde['ustidnr']),
 				'custom' => wpsg_getStr($kunde['custom']),
-				'shipping' => $order['type_shipping'],
-				'payment' => $order['type_payment'],
-				'comment' => $order['comment'],
-				'onr' => $order['onr'],
+				'shipping' => $order['type_shipping']??'',
+				'payment' => $order['type_payment']??'',
+				'comment' => $order['comment']??'',
+				'onr' => $order['onr']??'',
 				'knr' => wpsg_getStr($kunde['knr']),
-				'datum' => strtotime($order['cdate'])
+				'datum' => strtotime($order['cdate'])??''
 			);
 			
Index: /mods/wpsg_mod_abo.class.php
===================================================================
--- /mods/wpsg_mod_abo.class.php	(revision 8226)
+++ /mods/wpsg_mod_abo.class.php	(revision 8227)
@@ -974,5 +974,5 @@
 				{
 
-					$this->shop->view['wpsg_mod_abo']['rebuy'] = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_ORDERPRODUCT."` WHERE `productkey` LIKE 'abo_".wpsg_q($this->shop->view['data']['id'])."_%'");
+					$this->shop->view['wpsg_mod_abo']['rebuy'] = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_ORDERPRODUCT."` WHERE `productkey` LIKE 'abo_".wpsg_q($this->shop->view['data']['id']??'')."_%'");
 
 					foreach ($this->shop->view['wpsg_mod_abo']['rebuy'] as $k => $v)
Index: /mods/wpsg_mod_deliverynote.class.php
===================================================================
--- /mods/wpsg_mod_deliverynote.class.php	(revision 8226)
+++ /mods/wpsg_mod_deliverynote.class.php	(revision 8227)
@@ -914,5 +914,5 @@
 			    // Lieferschein aus Bestellung
 				$deliverynote = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_DELIVERYNOTE."` AS DN WHERE `order_id` = '".wpsg_q($order_id)."' ");
-				$datum = $deliverynote['cdate'];
+				if (isset($deliverynote)) $datum = $deliverynote['cdate'];
 				$ym = date('Y/m/', strtotime($datum));
 				